#ifndef _LIRCCD_H
#define _LIRCCD_H

#include <regex.h>

#include "command.h"

#define BIND_STOP 1
#define BIND_RECURSIVE 2

struct client
{
    struct client *next;
    int fd;
    int state;
    unsigned char *appname;
};

struct binding
{
    struct binding *next;
    struct binding *child;
    regex_t remote, button;
    struct instruction *code;
    int flags;
};

struct child
{
    struct child *next;
    int id;
    unsigned char *desc;
    int pid;
    int running, stopped;
    unsigned char *notify;
};

struct alarm
{
    struct alarm *next;
    int id;
    time_t time;
    unsigned char *func;
};

extern struct binding *bindings;
extern struct child *children;
extern struct alarm *alarms;
extern struct client *clients;
extern int endbinding;

struct binding *newbinding(unsigned char *remote, unsigned char *button, struct instruction *code);
void addbinding(struct binding **dest, struct binding *binding);
void freechild(struct child *child);
struct child *getchild(int id);
struct child *regchild(unsigned char *desc, int pid);
void freealarm(struct alarm *alarm);
struct alarm *regalarm(time_t time, unsigned char *func);

#endif
